/* MAC0499 - Trabalho de Formatura Supervisionado - Compresso de udio Digital
 * Marcio Masaki Tomiyoshi */

#include <stdio.h>

#include "common.h"
#include "io.h"
#include "encoder.h"
#include "decoder.h"

#if DEBUG != 0
void printSamples(FILE **input, char *filename, FILE *output, WaveHeader wh)
{
	unsigned int numSamples, bytesPerSample, i, j, sample;

	wh = openWave(input, filename);

	bytesPerSample = (unsigned int)wh.bitsPerSample / 8;
	numSamples = calculateSamplesNumber(wh);

	for (i = 0; i < numSamples; i++)
	{
		printf("\n%10d ", i);
		for (j = 0; j < wh.numChannels; j++)
		{
			sample = readWaveSample(*input, bytesPerSample);
			printf("C%d %7d ", j, sample);
		}
	}
}
#endif

int main(int argc, char *argv[])
{

	if (argc == 3) /* Encode */
		encode(argv[argc - 2], argv[argc - 1], FRAME_SIZE);
	else if (argc == 4)
	{
		if (strcmp("-d", argv[1]) == 0) /* Decode */
			decode(argv[argc - 2], argv[argc - 1]);
		#if DEBUG != 0
		else if (strcmp("-p", argv[1]) == 0) /* Print samples values - Testing only */
			printSamples(&input, argv[argc - 1], output, waveHeader);
		#endif
	}
	else
		showUsage(argv[0]);

	return 0;
}
