/* MAC0499 - Trabalho de Formatura Supervisionado - Compresso de udio Digital
 * Marcio Masaki Tomiyoshi */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"
#include "error.h"

/* io.h */
void writeBytes(FILE *output, char *str, int n);
void readBytes(FILE *input, char *output, int nbytes);
void writeLittleEndianBytes(FILE *output, int valor, int nbytes);
unsigned int readLittleEndianBytes(FILE *input, int nBytes);
int twoComplementToInt(int value, int bytes);
int intToTwoComplement(int value, int bytes);

/* wave */
WaveHeader createWaveHeader(FILE *input);
void copyWaveHeader(FILE *input, FILE *output);
int checkWaveHeader(WaveHeader wh);
int checkWaveHeaderConsistency(WaveHeader wh);
void printWaveHeader(FILE *output, WaveHeader wh);
unsigned int calculateChunkSize(WaveHeader wh);
unsigned int calculateByteRate(WaveHeader wh);
unsigned short int calculateBlockAlign(WaveHeader wh);
unsigned int calculateSamplesNumber(WaveHeader wh);
void outputWaveHeader(FILE *output, WaveHeader wh);
int readWaveSample(FILE *input, int nBytes);
void writeWaveSample(FILE *output, int value, int nBytes);
